// file.H

/*  Copyright (C) 1996-1997  Id Software, Inc.
    Copyright (C) 1997 Greg Lewis

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    See file, 'COPYING', for details.
*/

#ifndef FILE_H
#define FILE_H

#include <stdio.h>

class File
{
public:
	File(void);
	~File(void);
	bool  fOpen(char *szFile, char *szMode, bool fAbort = true);
	void  Close(void);
	int   LoadFile(char *szFile, void **pBuffer, bool fAbort = true);

	void Printf(char *szFormat, ...);
	void Flush(void);
	void Read(void *pBuffer, int cLen);
	void Write(void *pBuffer, int cLen);
	void Seek(long Offset, int origin);
	int  Position(void);
	int  Length(void);
	char *GetFName(void);

private:
	FILE *fp;
	char *FName;
};

#endif


