// wad.H

/*  Copyright (C) 1996-1997  Id Software, Inc.
    Copyright (C) 1997 Greg Lewis

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    See file, 'COPYING', for details.
*/

typedef struct
{
	char		identification[4];	// should be WAD2/WAD3
	int		numlumps;
	int		infotableofs;
} wadinfo_t;

typedef struct
{
	int		filepos;
	int		disksize;
	int		size;			// uncompressed
	char		type;
	char		compression;
	char		pad1, pad2;
	char		name[16];		// must be null terminated
} lumpinfo_t;

typedef struct
{
	wadinfo_t  header;
	lumpinfo_t *lumps;
	bool	   Wad3;
	File	   Wad;
//	char szName[512];
} wadlist_t;

#define	MIPLEVELS	4

// This struct was originally miptex_t
typedef struct miptex2_s
{
	char		name[16];
	unsigned	width, height;
	unsigned	offsets[MIPLEVELS];	// four mip maps stored
} miptex2_t; // 40 byte


class WAD
{
public:
	WAD(void);
	~WAD(void);
	bool InitWADList(char *szWadlist);
	void fProcessWAD(void);

private:
	char *szWadName;
	wadlist_t *wadlist;
	int iWad, cWads;

	void LoadTextures(dmiptexlump_t *l);
	void InitWadFile(void);
	int  LoadLump(char *szName, byte *pDest);
	void AddAnimatingTextures(void);
	void NeedArrayBytes (int Size);
	char *ExpandWadPath (char *Path);
};


